// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from foros_msgs:srv/AppendEntries.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__FUNCTIONS_H_
#define FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "foros_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "foros_msgs/srv/detail/append_entries__struct.h"

/// Initialize srv/AppendEntries message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * foros_msgs__srv__AppendEntries_Request
 * )) before or use
 * foros_msgs__srv__AppendEntries_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__init(foros_msgs__srv__AppendEntries_Request * msg);

/// Finalize srv/AppendEntries message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Request__fini(foros_msgs__srv__AppendEntries_Request * msg);

/// Create srv/AppendEntries message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * foros_msgs__srv__AppendEntries_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__srv__AppendEntries_Request *
foros_msgs__srv__AppendEntries_Request__create();

/// Destroy srv/AppendEntries message.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Request__destroy(foros_msgs__srv__AppendEntries_Request * msg);

/// Check for srv/AppendEntries message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__are_equal(const foros_msgs__srv__AppendEntries_Request * lhs, const foros_msgs__srv__AppendEntries_Request * rhs);

/// Copy a srv/AppendEntries message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__copy(
  const foros_msgs__srv__AppendEntries_Request * input,
  foros_msgs__srv__AppendEntries_Request * output);

/// Initialize array of srv/AppendEntries messages.
/**
 * It allocates the memory for the number of elements and calls
 * foros_msgs__srv__AppendEntries_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__Sequence__init(foros_msgs__srv__AppendEntries_Request__Sequence * array, size_t size);

/// Finalize array of srv/AppendEntries messages.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Request__Sequence__fini(foros_msgs__srv__AppendEntries_Request__Sequence * array);

/// Create array of srv/AppendEntries messages.
/**
 * It allocates the memory for the array and calls
 * foros_msgs__srv__AppendEntries_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__srv__AppendEntries_Request__Sequence *
foros_msgs__srv__AppendEntries_Request__Sequence__create(size_t size);

/// Destroy array of srv/AppendEntries messages.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Request__Sequence__destroy(foros_msgs__srv__AppendEntries_Request__Sequence * array);

/// Check for srv/AppendEntries message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__Sequence__are_equal(const foros_msgs__srv__AppendEntries_Request__Sequence * lhs, const foros_msgs__srv__AppendEntries_Request__Sequence * rhs);

/// Copy an array of srv/AppendEntries messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Request__Sequence__copy(
  const foros_msgs__srv__AppendEntries_Request__Sequence * input,
  foros_msgs__srv__AppendEntries_Request__Sequence * output);

/// Initialize srv/AppendEntries message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * foros_msgs__srv__AppendEntries_Response
 * )) before or use
 * foros_msgs__srv__AppendEntries_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__init(foros_msgs__srv__AppendEntries_Response * msg);

/// Finalize srv/AppendEntries message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Response__fini(foros_msgs__srv__AppendEntries_Response * msg);

/// Create srv/AppendEntries message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * foros_msgs__srv__AppendEntries_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__srv__AppendEntries_Response *
foros_msgs__srv__AppendEntries_Response__create();

/// Destroy srv/AppendEntries message.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Response__destroy(foros_msgs__srv__AppendEntries_Response * msg);

/// Check for srv/AppendEntries message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__are_equal(const foros_msgs__srv__AppendEntries_Response * lhs, const foros_msgs__srv__AppendEntries_Response * rhs);

/// Copy a srv/AppendEntries message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__copy(
  const foros_msgs__srv__AppendEntries_Response * input,
  foros_msgs__srv__AppendEntries_Response * output);

/// Initialize array of srv/AppendEntries messages.
/**
 * It allocates the memory for the number of elements and calls
 * foros_msgs__srv__AppendEntries_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__Sequence__init(foros_msgs__srv__AppendEntries_Response__Sequence * array, size_t size);

/// Finalize array of srv/AppendEntries messages.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Response__Sequence__fini(foros_msgs__srv__AppendEntries_Response__Sequence * array);

/// Create array of srv/AppendEntries messages.
/**
 * It allocates the memory for the array and calls
 * foros_msgs__srv__AppendEntries_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__srv__AppendEntries_Response__Sequence *
foros_msgs__srv__AppendEntries_Response__Sequence__create(size_t size);

/// Destroy array of srv/AppendEntries messages.
/**
 * It calls
 * foros_msgs__srv__AppendEntries_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__srv__AppendEntries_Response__Sequence__destroy(foros_msgs__srv__AppendEntries_Response__Sequence * array);

/// Check for srv/AppendEntries message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__Sequence__are_equal(const foros_msgs__srv__AppendEntries_Response__Sequence * lhs, const foros_msgs__srv__AppendEntries_Response__Sequence * rhs);

/// Copy an array of srv/AppendEntries messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__srv__AppendEntries_Response__Sequence__copy(
  const foros_msgs__srv__AppendEntries_Response__Sequence * input,
  foros_msgs__srv__AppendEntries_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__FUNCTIONS_H_
